package juliac.generated;

import java.util.ArrayList;
import org.objectweb.fractal.api.control.AttributeController;
import org.objectweb.fractal.julia.type.BasicComponentType;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.julia.factory.ChainedInstantiationException;
import org.objectweb.fractal.julia.control.attribute.CloneableAttributeController;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import org.objectweb.fractal.api.factory.GenericFactory;
import java.util.HashMap;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalContentException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.Interface;
import org.objectweb.fractal.api.type.InterfaceType;
import java.util.List;
import java.util.Map;
import org.objectweb.fractal.api.control.NameController;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.julia.factory.Template;
import org.objectweb.fractal.api.Type;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.objectweb.fractal.julia.factory.BasicTemplateMixin
 * @see org.objectweb.fractal.julia.control.attribute.UseCloneableAttributeControllerMixin
 * @see org.objectweb.fractal.julia.factory.AttributeTemplateMixin
 * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin
 * @see org.objectweb.fractal.julia.factory.NameTemplateMixin
 */
public class FactoryImpl implements Controller , Template , Generated {
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$3(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin#weaveableOptNC
     */
    public NameController weaveableOptNC;
    
    /** 
     * @see org.objectweb.fractal.julia.control.attribute.UseCloneableAttributeControllerMixin#weaveableOptCAC
     */
    public CloneableAttributeController weaveableOptCAC;
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * @see org.objectweb.fractal.julia.factory.NameTemplateMixin#newFcControllerInstance()
     */
    public Component newFcControllerInstance() throws InstantiationException {
        Component comp = newFcControllerInstance$0();
        if ((weaveableOptNC) != null) {
            try {
                String name = weaveableOptNC.getFcName();
                ((NameController)(comp.getFcInterface("name-controller"))).setFcName(name);
            } catch (NoSuchInterfaceException ignored) {
            }
        } 
        return comp;
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableOptNC = ((NameController)(ic.getOptionalInterface("name-controller")));
        initFcController$0(ic);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.factory.AttributeTemplateMixin#newFcControllerInstance()
     */
    private Component newFcControllerInstance$0() throws InstantiationException {
        Component comp = newFcControllerInstance$1();
        if ((weaveableOptCAC) != null) {
            try {
                weaveableOptCAC.cloneFcAttributes(((AttributeController)(comp.getFcInterface("attribute-controller"))));
            } catch (NoSuchInterfaceException ignored) {
            }
        } 
        return comp;
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.attribute.UseCloneableAttributeControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        weaveableOptCAC = ((CloneableAttributeController)(ic.getOptionalInterface("/cloneable-attribute-controller")));
        initFcController$1(ic);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$2(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$3(ic);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.factory.BasicTemplateMixin#fcInstanceType
     */
    public Type fcInstanceType;
    
    private void initFcController$4(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.fractal.julia.factory.BasicTemplateMixin#fcContent
     */
    public Object[] fcContent;
    
    private Component newFcControllerInstance$2() throws InstantiationException {
        return null;
    }
    
    /** 
     * @see org.objectweb.fractal.julia.factory.BasicTemplateMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
        fcContent = ((Object[])(ic.content));
        ComponentType tmplType = ((ComponentType)(ic.type));
        InterfaceType[] itfTypes = tmplType.getFcInterfaceTypes();
        List itfList = new ArrayList();
        for (int j = 0 ; j < (itfTypes.length) ; ++j) {
            String n = itfTypes[j].getFcItfName();
            if ((!(n.equals("factory"))) && (!(n.equals("/template")))) {
                if (n.equals("attribute-controller")) {
                    itfList.add(itfTypes[j]);
                } else if (!((n.equals("component")) || (n.endsWith("-controller")))) {
                    itfList.add(itfTypes[j]);
                } 
            } 
        }
        itfTypes = new InterfaceType[itfList.size()];
        itfTypes = ((InterfaceType[])(itfList.toArray(itfTypes)));
        fcInstanceType = new BasicComponentType(itfTypes);
        initFcController$2(ic);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.factory.BasicTemplateMixin#getFcInstanceType()
     */
    public Type getFcInstanceType() {
        return fcInstanceType;
    }
    
    /** 
     * @see org.objectweb.fractal.julia.factory.BasicTemplateMixin#getFcControllerDesc()
     */
    public Object getFcControllerDesc() {
        return fcContent[0];
    }
    
    /** 
     * @see org.objectweb.fractal.julia.factory.BasicTemplateMixin#getFcContentDesc()
     */
    public Object getFcContentDesc() {
        return fcContent[1];
    }
    
    /** 
     * @see org.objectweb.fractal.julia.factory.BasicTemplateMixin#newFcInstance()
     */
    public Component newFcInstance() throws InstantiationException {
        Component thisComponent;
        try {
            thisComponent = ((Component)(weaveableC.getFcInterface("component")));
        } catch (NoSuchInterfaceException e) {
            throw new ChainedInstantiationException(e , weaveableC , "The template component must provide the Component interface");
        }
        List allSubTemplates = org.objectweb.fractal.julia.control.content.Util.getAllSubComponents(thisComponent);
        Map instances = new HashMap();
        for (int i = 0 ; i < (allSubTemplates.size()) ; ++i) {
            Component tmpl = ((Component)(allSubTemplates.get(i)));
            Template t;
            try {
                t = ((Template)(tmpl.getFcInterface("factory")));
            } catch (Exception e) {
                try {
                    t = ((Template)(tmpl.getFcInterface("/template")));
                } catch (NoSuchInterfaceException f) {
                    throw new ChainedInstantiationException(f , weaveableC , "All the (sub) templates must provide the Template interface");
                }
            }
            Component instance = t.newFcControllerInstance();
            instances.put(tmpl ,instance);
        }
        for (int i = 0 ; i < (allSubTemplates.size()) ; ++i) {
            Component tmpl = ((Component)(allSubTemplates.get(i)));
            Component instance = ((Component)(instances.get(tmpl)));
            ContentController tmplCC;
            ContentController instanceCC;
            try {
                tmplCC = ((ContentController)(tmpl.getFcInterface("content-controller")));
            } catch (NoSuchInterfaceException e) {
                continue;
            }
            try {
                instanceCC = ((ContentController)(instance.getFcInterface("content-controller")));
            } catch (NoSuchInterfaceException e) {
                throw new ChainedInstantiationException(e , tmpl , "A component instantiated from a template with a ContentController interface must provide the ContentController interface");
            }
            Component[] subTemplates = tmplCC.getFcSubComponents();
            Component[] subInstances = instanceCC.getFcSubComponents();
            for (int j = 0 ; j < (subTemplates.length) ; ++j) {
                Component subInstance = ((Component)(instances.get(subTemplates[j])));
                boolean add = true;
                for (int k = 0 ; k < (subInstances.length) ; ++k) {
                    if (subInstances[k].equals(subInstance)) {
                        add = false;
                    } 
                }
                if (add) {
                    try {
                        instanceCC.addFcSubComponent(subInstance);
                    } catch (IllegalContentException e) {
                        throw new ChainedInstantiationException(e , tmpl , "Cannot set the component hierarchy from the template hierarchy");
                    } catch (IllegalLifeCycleException e) {
                        throw new ChainedInstantiationException(e , tmpl , "Cannot set the component hierarchy from the template hierarchy");
                    }
                } 
            }
        }
        for (int i = 0 ; i < (allSubTemplates.size()) ; ++i) {
            Component tmpl = ((Component)(allSubTemplates.get(i)));
            Component instance = ((Component)(instances.get(tmpl)));
            BindingController tmplBC;
            BindingController instanceBC;
            try {
                tmplBC = ((BindingController)(tmpl.getFcInterface("binding-controller")));
            } catch (NoSuchInterfaceException e) {
                continue;
            }
            try {
                instanceBC = ((BindingController)(instance.getFcInterface("binding-controller")));
            } catch (NoSuchInterfaceException e) {
                throw new ChainedInstantiationException(e , tmpl , "A component instantiated from a template with a BindingController interface must provide the BindingController interface");
            }
            String[] itfNames = tmplBC.listFc();
            for (int j = 0 ; j < (itfNames.length) ; ++j) {
                String itfName = itfNames[j];
                Interface serverItf;
                try {
                    serverItf = ((Interface)(tmplBC.lookupFc(itfName)));
                } catch (ClassCastException e) {
                    throw new ChainedInstantiationException(e , tmpl , "The server interface of each binding between templates must implement the Interface interface");
                } catch (NoSuchInterfaceException e) {
                    throw new ChainedInstantiationException(e , tmpl , (("The \'" + itfName) + "\' interface returned by the listFc method does not exist"));
                }
                if (serverItf == null) {
                    continue;
                } 
                Component serverTmpl = serverItf.getFcItfOwner();
                Component serverInstance = ((Component)(instances.get(serverTmpl)));
                if (serverInstance == null) {
                    continue;
                } 
                Object itfValue;
                try {
                    if (serverItf.isFcInternalItf()) {
                        ContentController cc = ((ContentController)(serverInstance.getFcInterface("content-controller")));
                        itfValue = cc.getFcInternalInterface(serverItf.getFcItfName());
                    } else {
                        itfValue = serverInstance.getFcInterface(serverItf.getFcItfName());
                    }
                } catch (NoSuchInterfaceException e) {
                    throw new ChainedInstantiationException(e , serverTmpl , (("The server interface \'" + (serverItf.getFcItfName())) + "\'is missing in the component instantiated from the template"));
                }
                try {
                    if (instanceBC.lookupFc(itfName).equals(itfValue)) {
                        continue;
                    } 
                } catch (Exception e) {
                }
                try {
                    instanceBC.bindFc(itfName ,itfValue);
                } catch (NoSuchInterfaceException e) {
                    throw new ChainedInstantiationException(e , tmpl , "Cannot set the component bindings from the template bindings");
                } catch (IllegalBindingException e) {
                    throw new ChainedInstantiationException(e , tmpl , "Cannot set the component bindings from the template bindings");
                } catch (IllegalLifeCycleException e) {
                    throw new ChainedInstantiationException(e , tmpl , "Cannot set the component bindings from the template bindings");
                }
            }
        }
        return ((Component)(instances.get(allSubTemplates.get(0))));
    }
    
    /** 
     * @see org.objectweb.fractal.julia.factory.BasicTemplateMixin#newFcControllerInstance()
     */
    private Component newFcControllerInstance$1() throws InstantiationException {
        if ((fcContent[1]) instanceof Component) {
            return ((Component)(fcContent[1]));
        } 
        GenericFactory factory;
        try {
            factory = ((GenericFactory)(org.objectweb.fractal.api.Fractal.getBootstrapComponent().getFcInterface("generic-factory")));
        } catch (InstantiationException e) {
            throw new ChainedInstantiationException(e , weaveableC , "Cannot find the GenericFactory interface of the bootstrap component, which is needed to instantiate the template");
        } catch (NoSuchInterfaceException e) {
            throw new ChainedInstantiationException(e , weaveableC , "Cannot find the GenericFactory interface of the bootstrap component, which is needed to instantiate the template");
        }
        return factory.newFcInstance(fcInstanceType ,fcContent[0] ,fcContent[1]);
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.FactoryImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.UseComponentMixin org.objectweb.fractal.julia.factory.BasicTemplateMixin org.objectweb.fractal.julia.control.attribute.UseCloneableAttributeControllerMixin org.objectweb.fractal.julia.factory.AttributeTemplateMixin org.objectweb.fractal.julia.control.name.UseNameControllerMixin org.objectweb.fractal.julia.factory.NameTemplateMixin)";
    }
    
}

